//--------------------------------------------------------------------
//     此代码由T4模板自动生成  byzhouhang 20210918
//	   生成时间 2022-10-20 11:52:17 
//     对此文件的更改可能会导致不正确的行为，并且如果重新生成代码，这些更改将会丢失。
//--------------------------------------------------------------------

using IRaCIS.Core.Domain.Models;
using Microsoft.AspNetCore.Mvc;
using IRaCIS.Core.Application.Interfaces;
using IRaCIS.Core.Application.ViewModel;
using IRaCIS.Core.Domain.Share;
using IRaCIS.Core.Infrastructure;
using IRaCIS.Core.Application.Helper;
using IRaCIS.Application.Contracts;
using IRaCIS.Core.Infra.EFCore.Common;

namespace IRaCIS.Core.Application.Service
{
    /// <summary>
    /// TrialEmailNoticeConfigService
    /// </summary>	
    [ApiExplorerSettings(GroupName = "Trial")]
    public class TrialEmailNoticeConfigService : BaseService, ITrialEmailNoticeConfigService
    {

        private readonly IRepository<TrialEmailNoticeConfig> _trialEmailNoticeConfigRepository;

        public IRepository<VisitTask> _visitTaskRepository { get; }
        public IRepository<TrialUser> _trialUserRepository { get; }

        public TrialEmailNoticeConfigService(IRepository<TrialEmailNoticeConfig> trialEmailNoticeConfigRepository, IRepository<VisitTask> visitTaskRepository, IRepository<TrialUser> trialUserRepository)
        {
            _trialEmailNoticeConfigRepository = trialEmailNoticeConfigRepository;
            _visitTaskRepository = visitTaskRepository;
            _trialUserRepository = trialUserRepository;
        }


        /// <summary>
        /// 同步系统配置的文档到想项目中
        /// </summary>
        /// <param name="trialId"></param>
        /// <param name="criterionTypeEnum"></param>
        /// <returns></returns>
        /// 
        private async Task SyncSystemEmainCofigDocListAsync(Guid trialId, CriterionType? criterionTypeEnum)
        {
            if (criterionTypeEnum != null)
            {
                var docmentList = _repository.Where<CommonDocument>(t => t.CriterionTypeEnum == criterionTypeEnum).Select(t => new { t.Path, t.Name, t.Code, t.BusinessScenarioEnum }).ToList();

                var trialDocCount = _trialEmailNoticeConfigRepository.Where(t => t.CriterionTypeEnum == criterionTypeEnum && t.TrialId == trialId).Count();

                if (trialDocCount == 0)
                {

                    foreach (var item in docmentList)
                    {
                        await _trialEmailNoticeConfigRepository.AddAsync(new TrialEmailNoticeConfig() { FileName = item.Name, FilePath = item.Path, BusinessScenarioEnum = item.BusinessScenarioEnum, Code = item.Code });
                    }

                }

            }

            await _trialEmailNoticeConfigRepository.SaveChangesAsync();
        }



        /// <summary>
        /// 测试邮件 带附件 填充word --前端不需要用
        /// </summary>
        /// <param name="trialId"></param>
        /// <param name="visitTaskId"></param>
        /// <param name="trialReadingCriterionId"></param>
        /// <param name="businessScenarioEnum"></param>
        /// <returns></returns>
        /// <exception cref="BusinessValidationFailedException"></exception>
        public async Task FillWordTemplateAndEmailConfig(Guid trialId, Guid visitTaskId, Guid trialReadingCriterionId, CommonDocumentBusinessScenario businessScenarioEnum)
        {
            var criterionTypeEnum = await _repository.Where<ReadingQuestionCriterionTrial>(t => t.TrialId == trialId && t.Id == trialReadingCriterionId).Select(t => t.CriterionType).FirstOrDefaultAsync();


            var emailConfig = await _trialEmailNoticeConfigRepository.Where(t => t.TrialId == trialId && t.CriterionTypeEnum == criterionTypeEnum && t.BusinessScenarioEnum == businessScenarioEnum)
                .Include(t => t.TrialEmailNoticeUserList).ThenInclude(t => t.User).FirstOrDefaultAsync();

            if (emailConfig == null)
            {
                throw new BusinessValidationFailedException("找不到该项目标准场景下邮件的配置");
            }

            //填充邮件基本配置

            var sendEmailConfig = new SMTPEmailConfig();

            foreach (var item in emailConfig.TrialEmailNoticeUserList)
            {

                if (item.User.EMail.Contains("@") && !string.IsNullOrEmpty(item.User.EMail))
                {
                    switch (item.EmailUserType)
                    {
                        case EmailUserType.From:
                            sendEmailConfig.FromEmailAddress = new MimeKit.MailboxAddress(item.User.FullName, item.User.EMail);

                            break;
                        case EmailUserType.To:
                            sendEmailConfig.ToMailAddressList.Add(new MimeKit.MailboxAddress(item.User.FullName, item.User.EMail));

                            break;
                        case EmailUserType.Copy:
                            sendEmailConfig.CopyToMailAddressList.Add(new MimeKit.MailboxAddress(item.User.FullName, item.User.EMail));

                            break;

                        default:
                            break;
                    }
                }
            }


            //邮件附件
            var path = FileStoreHelper.GetPhysicalFilePath(_hostEnvironment, emailConfig.FilePath);

            if (!File.Exists(path))
            {
                throw new BusinessValidationFailedException("找不到该项目标准场景下邮件模板");
            }

            //邮件内容html
            var isNeedSend = await FillWordTemplateAndSetEmailAsync(visitTaskId, sendEmailConfig, businessScenarioEnum, emailConfig.FilePath, path);

           

         



            await SendEmailHelper.SendEmailAsync(sendEmailConfig);

        }



        private async Task<bool> FillWordTemplateAndSetEmailAsync(Guid visitTaskId, SMTPEmailConfig sendEmailConfig, CommonDocumentBusinessScenario businessScenarioEnum, string  fileName,string templatePath)
        {

            var isNeedSend = true;
            var answer = "否";


            var pathToFile = _hostEnvironment.WebRootPath
                       + Path.DirectorySeparatorChar.ToString()
                       + "EmailTemplate"
                       + Path.DirectorySeparatorChar.ToString()
                       + "SubjectEnrollConfirmOrPDProgress.html";


            var documentNeedBasicInfo = await _visitTaskRepository.Where(t => t.Id == visitTaskId).Select(t => new
            {
                t.Trial.ResearchProgramNo,
                t.Subject.TrialSite.TrialSiteCode,
                SubjectCode = t.Subject.Code,
                t.Trial.Sponsor.SponsorName,
                t.Trial.IsEnrollementQualificationConfirm,
                t.Trial.IsPDProgressView,

                IsBaseline = t.SourceSubjectVisit.IsBaseLine,
                VisitEarliestScanDate = t.SourceSubjectVisit.EarliestScanDate,
                VisitName = t.SourceSubjectVisit.VisitName,
                t.SourceSubjectVisit.IsFinalVisit,
                t.SourceSubjectVisit.PDState,

                ModuleEarliestScanDate = t.ReadModule.SubjectVisit.EarliestScanDate,
                ModuleVisitName = t.ReadModule.SubjectVisit.VisitName,
                t.SourceSubjectVisitId,
                t.SouceReadModuleId,
                t.SubjectId,

                t.ReadingTaskState,
                t.ReadingCategory,
                t.SignTime,

                t.TrialReadingCriterionId,
                t.TrialReadingCriterion.ArbitrationRule,
                t.TrialReadingCriterion.ReadingType,
                t.TrialReadingCriterion.IsReadingTaskViewInOrder,
            }).FirstNotNullAsync();


            if (documentNeedBasicInfo.ReadingCategory == ReadingCategory.Visit || documentNeedBasicInfo.ReadingCategory == ReadingCategory.Judge || documentNeedBasicInfo.ReadingCategory == ReadingCategory.Global)
            {

            }
            else
            {
                //isNeedSend = false;
                return false;
            }

            //入组确认仅在基线
            if (businessScenarioEnum == CommonDocumentBusinessScenario.EnrollConfirmed && documentNeedBasicInfo.IsEnrollementQualificationConfirm && documentNeedBasicInfo.IsBaseline)
            {

                //如果其他阅片人已经做了，说明发送了入组确认报告，第二个人做完就不发送了

                if (await _visitTaskRepository.AnyAsync(t => t.SourceSubjectVisitId == documentNeedBasicInfo.SourceSubjectVisitId && t.TaskState == TaskState.Effect && t.IsAnalysisCreate == false &&
                t.Id != visitTaskId && t.ReadingTaskState == ReadingTaskState.HaveSigned))
                {
                    //isNeedSend = false;

                    return false;
                }

                sendEmailConfig.TopicDescription = "入组确认";

                using (StreamReader SourceReader = System.IO.File.OpenText(pathToFile))
                {
                    var templateInfo = SourceReader.ReadToEnd();


                    sendEmailConfig.HtmlBodyStr = string.Format(templateInfo,
                        $" 附件为入组确认报告，请查收 "
                        );
                }



                if (await _repository.Where<ReadingTableQuestionAnswer>().AnyAsync(x => x.VisitTaskId == visitTaskId && x.Answer == TargetState.Exist.GetEnumInt() &&
                x.ReadingTableQuestionTrial.QuestionMark == QuestionMark.State && x.ReadingQuestionTrial.LesionType == LesionType.TargetLesion))
                {

                    answer = "是";

                    //修改Subject  状态 need to do

                }


            }
            else if (businessScenarioEnum == CommonDocumentBusinessScenario.PDConfirmed && documentNeedBasicInfo.IsPDProgressView)
            {

                sendEmailConfig.TopicDescription = "疾病进展";

                using (StreamReader SourceReader = System.IO.File.OpenText(pathToFile))
                {
                    var templateInfo = SourceReader.ReadToEnd();


                    sendEmailConfig.HtmlBodyStr = string.Format(templateInfo,
                        $" 附件为疾病进展确认报告，请查收 "
                        );
                }

                //有序

                if (documentNeedBasicInfo.IsReadingTaskViewInOrder)
                {


                    //单重

                    if (documentNeedBasicInfo.ReadingType == ReadingMethod.Single)
                    {
                        //仲裁在访视上   或者在阅片期
                        if (documentNeedBasicInfo.ArbitrationRule != ArbitrationRule.None)
                        {

                            throw new BusinessValidationFailedException("单重有序阅片配置有误(不应该有仲裁对象配置)，请核查！");
                        }


                        //要求PD 确认的访视  是截止访视 还是非截止访视(根据该访视有没有配置阅片期来判断)

                        if (documentNeedBasicInfo.ReadingCategory == ReadingCategory.Visit)
                        {
                            //存在阅片期  那么就是截止访视
                            if (await _repository.Where<ReadModule>(t => t.TrialReadingCriterionId == documentNeedBasicInfo.TrialReadingCriterionId && t.SubjectVisitId == documentNeedBasicInfo.SourceSubjectVisitId && t.ReadingSetType == ReadingSetType.ImageReading).AnyAsync())
                            {
                                isNeedSend = false;
                            }
                            else//非截止访视
                            {
                                answer = await TranslatePdStateAsync(visitTaskId, ReadingCategory.Visit);
                            }
                        }
                        else if (documentNeedBasicInfo.ReadingCategory == ReadingCategory.Global)
                        {
                            answer = await TranslatePdStateAsync(visitTaskId, ReadingCategory.Global);
                        }
                        else
                        {
                            throw new BusinessValidationFailedException("单重有序阅片 该类型的任务不应进入此处逻辑，请联系后台开发核查！");
                        }


                    }
                    //双重
                    else if (documentNeedBasicInfo.ReadingType == ReadingMethod.Double)
                    {


                        //仲裁在访视上   就没有全局阅片 没有阅片期
                        if (documentNeedBasicInfo.ArbitrationRule == ArbitrationRule.Visit)
                        {
                            //找到 访视，裁判 所有有效任务(不可能有全局的)   访视和裁判任务的SourceSubjectVisitId 一样
                            var taskList = await _visitTaskRepository.Where(t => t.SourceSubjectVisitId == documentNeedBasicInfo.SourceSubjectVisitId && t.IsAnalysisCreate == false && t.TaskState == TaskState.Effect && 
                            (t.ReadingCategory == ReadingCategory.Visit || t.ReadingCategory == ReadingCategory.Judge )).ToListAsync();


                            //这里要求 到这里已经如果有裁判  已经生成裁判了保存数据库
                            //双人阅片，没有产生裁判 第二个人读完发
                            if (taskList.Count == 2 && taskList.Count(t => t.ReadingTaskState == ReadingTaskState.HaveSigned && t.ReadingCategory == ReadingCategory.Visit) == 2)
                            {

                                answer = await TranslatePdStateAsync(visitTaskId, documentNeedBasicInfo.ReadingCategory);
                            }
                            //双人  产生裁判，并且裁判完成 发
                            else if (taskList.Count == 3 && taskList.Count(t => t.ReadingTaskState == ReadingTaskState.HaveSigned) == 3 && taskList.Where(t => t.ReadingCategory == ReadingCategory.Judge).Count() == 1)
                            {

                                answer = await TranslatePdStateAsync(taskList.Where(t => t.ReadingCategory == ReadingCategory.Judge).First().Id, ReadingCategory.Judge);

                            }
                            else
                            {
                                //isNeedSend = false;

                                return false;
                            }

                           
                        }
                        //在阅片期  仲裁在全局阅片，不会在访视上  
                        else if (documentNeedBasicInfo.ArbitrationRule == ArbitrationRule.Reading)
                        {
                            //是访视任务  不可能是裁判任务（访视上不会生成裁判），也不会是全局任务（全局任务 SourceSubjectVisitId=null ）
                            if (documentNeedBasicInfo.SourceSubjectVisitId != null)
                            {

                                #region MyRegion

                                ////看该访视是否是截止访视 
                                //var moduleIdList = await _repository.Where<ReadModule>(t => t.TrialReadingCriterionId == documentNeedBasicInfo.TrialReadingCriterionId && t.SubjectVisitId == documentNeedBasicInfo.SourceSubjectVisitId && t.ReadingSetType == ReadingSetType.ImageReading)
                                //    .Select(t => (Guid?) t.Id).ToListAsync();

                                ////截止访视
                                //if (moduleIdList.Count > 0)
                                //{
                                //    //截止访视，需要等待生成全局，完成全局再发

                                //    isNeedSend = false;

                                //}
                                ////非截止访视    CRC在该访视设置PD后，在提交的时候，生成了阅片期，一定会生成全局任务
                                //else
                                //{

                                //    isNeedSend = false;
                                //}

                                #endregion


                                //访视类型的任务  根本就不需要发送邮件

                                isNeedSend = false;

                            }
                            //是全局任务 或者全局的裁判任务   (如果是全局任务，那么此时裁判任务已经生成，如果是全局裁判)
                            else if (documentNeedBasicInfo.SouceReadModuleId != null)
                            {
                                var taskList = await _visitTaskRepository.Where(t => t.IsAnalysisCreate == false && t.TaskState == TaskState.Effect &&   t.SouceReadModuleId== documentNeedBasicInfo.SouceReadModuleId 
                                && (t.ReadingCategory == ReadingCategory.Global || t.ReadingCategory == ReadingCategory.Judge)).ToListAsync();

                                //两个全局没有裁判
                                if (taskList.Count == 2 && taskList.Count(t => t.ReadingTaskState == ReadingTaskState.HaveSigned && t.ReadingCategory == ReadingCategory.Global) == 2)
                                {

                                    answer = await TranslatePdStateAsync(visitTaskId, documentNeedBasicInfo.ReadingCategory);
                                }
                                //双人全局产生裁判
                                else if (taskList.Count == 3 && taskList.Count(t => t.ReadingTaskState == ReadingTaskState.HaveSigned) == 3 && taskList.Where(t => t.ReadingCategory == ReadingCategory.Judge).Count() == 1 && taskList.Where(t => t.ReadingCategory == ReadingCategory.Global).Count() == 2)
                                {

                                    answer = await TranslatePdStateAsync(taskList.Where(t => t.ReadingCategory == ReadingCategory.Judge).First().Id, ReadingCategory.Judge);

                                }
                                else
                                {
                                    //isNeedSend = false;

                                    return false;
                                }
                            }



                        }
                        else
                        {
                            throw new BusinessValidationFailedException("双重有序阅片 没有定义该仲裁规则处理逻辑，请联系业务和后台开发核查！");
                        }


                    }
                    else
                    {
                        throw new BusinessValidationFailedException("有序阅片配置有误(应为单重或者双重阅片)，请核查！");
                    }


                }
                //无序
                else
                {
                    //单重


                    if (documentNeedBasicInfo.ReadingType == ReadingMethod.Single && documentNeedBasicInfo.ArbitrationRule == ArbitrationRule.None)
                    {
                        answer = await TranslatePdStateAsync(visitTaskId, documentNeedBasicInfo.ReadingCategory);
                    }
                    //双重  截止访视只在阅片期的时候存在  要求PD确认的访视 肯定是非截止访视
                    else if (documentNeedBasicInfo.ReadingType == ReadingMethod.Double && documentNeedBasicInfo.ArbitrationRule == ArbitrationRule.Visit)
                    {
                        //在两位阅片人读完访视后，如果有裁判者等裁判读完，如果无裁判则等第二个人的读完

                        var taskList = await _visitTaskRepository.Where(t => t.SourceSubjectVisitId == documentNeedBasicInfo.SourceSubjectVisitId && t.IsAnalysisCreate == false && t.TaskState == TaskState.Effect && (t.ReadingCategory == ReadingCategory.Visit || t.ReadingCategory == ReadingCategory.Judge)).ToListAsync();

                        //这里要求 到这里已经如果有裁判  已经生成裁判了保存数据库
                        if (taskList.Count == 2 && taskList.Count(t => t.ReadingTaskState == ReadingTaskState.HaveSigned && t.ReadingCategory == ReadingCategory.Visit) == 2)
                        {

                            answer = await TranslatePdStateAsync(visitTaskId, documentNeedBasicInfo.ReadingCategory);
                        }
                        else if (taskList.Count == 3 && taskList.Count(t => t.ReadingTaskState == ReadingTaskState.HaveSigned) == 3 && taskList.Where(t => t.ReadingCategory == ReadingCategory.Judge).Count() == 1)
                        {

                            answer = await TranslatePdStateAsync(taskList.Where(t => t.ReadingCategory == ReadingCategory.Judge).First().Id, ReadingCategory.Judge);

                        }
                        else
                        {
                            //isNeedSend = false;
                            return false;
                        }

                    }
                    else
                    {
                        throw new BusinessValidationFailedException("无序阅片配置有误(应为单重无仲裁对象，双重针对访视仲裁)，请核查！");

                    }

                }

            }


            if (isNeedSend)
            {


                var value = new Dictionary<string, object>()
                {
                    ["SponsorName"] = documentNeedBasicInfo.SponsorName,
                    ["ResearchProgramNo"] = documentNeedBasicInfo.ResearchProgramNo,
                    ["TrialSiteCode"] = documentNeedBasicInfo.TrialSiteCode,
                    ["SubjectCode"] = documentNeedBasicInfo.SubjectCode,
                    ["VisitName"] = documentNeedBasicInfo.VisitName,
                    ["EarliestScanDate"] = documentNeedBasicInfo.SourceSubjectVisitId!=null?   documentNeedBasicInfo.VisitEarliestScanDate: documentNeedBasicInfo.ModuleEarliestScanDate,
                    ["SignTime"] = documentNeedBasicInfo.SignTime,
                    ["Result"] = answer

                };

                MemoryStream memoryStream = new MemoryStream();


                MiniSoftware.MiniWord.SaveAsByTemplate(memoryStream, templatePath, value);

                sendEmailConfig.EmailAttachMentConfigList.Add(new EmailAttachMentConfig()
                {
                    FileName = fileName,

                    FileStream = memoryStream
                });

                return false;
            }
            else
            {
                return false;
            }
        }


        private async Task<string> TranslatePdStateAsync(Guid visitTaskId, ReadingCategory readingCategory)
        {

            var answer = string.Empty;

            if (readingCategory == ReadingCategory.Visit)
            {
                var questionAnsewer = await _repository.Where<ReadingTaskQuestionAnswer>(t => t.VisitTaskId == visitTaskId && t.ReadingQuestionTrial.QuestionType == QuestionType.Tumor).FirstNotNullAsync();

                answer = questionAnsewer.Answer;
            }
            else if (readingCategory == ReadingCategory.Global)
            {
                var questionAnsewer = await _repository.Where<ReadingGlobalTaskInfo>(t => t.TaskId == visitTaskId && t.TrialReadingQuestion.QuestionType == QuestionType.Tumor).FirstNotNullAsync();

                answer = questionAnsewer.Answer;
            }
            else if (readingCategory == ReadingCategory.Judge)
            {
                var judgeResultTaskId = await _visitTaskRepository.Where(t => t.Id == visitTaskId).Select(t => t.JudgeResultTaskId).FirstNotNullAsync();

                var questionAnsewer = await _repository.Where<ReadingTaskQuestionAnswer>(t => t.VisitTaskId == judgeResultTaskId && t.ReadingQuestionTrial.QuestionType == QuestionType.Tumor).FirstNotNullAsync();

                answer = questionAnsewer.Answer;
            }
            else
            {
                throw new BusinessValidationFailedException("不应有 除访视、裁判、全局其他类型的任务进行发送邮件，请核查业务逻辑");
            }



            if (answer == OverallAssessment.PD.GetEnumInt())
            {
                return "是";
            }
            if (answer == OverallAssessment.NA.GetEnumInt())
            {
                return "NA";
            }
            else
            {
                return "否";
            }
        }


        /// <summary>
        /// 选择人员下拉
        /// </summary>
        /// <param name="trialId"></param>
        /// <returns></returns>
        public async Task<List<TrialUserSelct>> GetTrialUserSelectList(Guid trialId)
        {

            var query = _trialUserRepository.Where(t => t.TrialId == trialId && t.IsDeleted == false, false, true).IgnoreQueryFilters()

                .ProjectTo<TrialUserSelct>(_mapper.ConfigurationProvider);

            return await query.ToListAsync();

        }

        [HttpPost]
        public async Task<List<TrialEmailNoticeConfigView>> GetTrialEmailNoticeConfigList(TrialEmailNoticeConfigQuery inQuery)
        {

            await SyncSystemEmainCofigDocListAsync(inQuery.TrialId, inQuery.CriterionTypeEnum);

            var trialEmailNoticeConfigQueryable = _trialEmailNoticeConfigRepository.Where(t => t.TrialId == inQuery.TrialId)
              .WhereIf(inQuery.CriterionTypeEnum != null, t => t.CriterionTypeEnum == inQuery.CriterionTypeEnum)
              .WhereIf(inQuery.BusinessScenarioEnum != null, t => t.BusinessScenarioEnum == inQuery.BusinessScenarioEnum)
              .ProjectTo<TrialEmailNoticeConfigView>(_mapper.ConfigurationProvider);

            return await trialEmailNoticeConfigQueryable.ToListAsync();
        }


        public async Task<IResponseOutput> AddOrUpdateTrialEmailNoticeConfig(TrialEmailNoticeConfigAddOrEdit addOrEditTrialEmailNoticeConfig)
        {

            //var entity = await _trialEmailNoticeConfigRepository.InsertOrUpdateAsync(addOrEditTrialEmailNoticeConfig);

            if (addOrEditTrialEmailNoticeConfig.Id == null)
            {

                var entity = _mapper.Map<TrialEmailNoticeConfig>(addOrEditTrialEmailNoticeConfig);


                foreach (var item in addOrEditTrialEmailNoticeConfig.ToUserIdList)
                {
                    entity.TrialEmailNoticeUserList.Add(new TrialEmailNoticeUser() { EmailUserType = EmailUserType.To, UserId = item });

                }

                foreach (var item in addOrEditTrialEmailNoticeConfig.CopyUserIdList)
                {
                    entity.TrialEmailNoticeUserList.Add(new TrialEmailNoticeUser() { EmailUserType = EmailUserType.Copy, UserId = item });

                }


                await _trialEmailNoticeConfigRepository.AddAsync(entity, true);

                return ResponseOutput.Ok(entity.Id.ToString());



            }
            else
            {
                await _repository.BatchDeleteAsync<TrialEmailNoticeUser>(t => t.TrialEmailNoticeConfigId == addOrEditTrialEmailNoticeConfig.Id);


                var entity = (await _trialEmailNoticeConfigRepository.Where(t => t.Id == addOrEditTrialEmailNoticeConfig.Id, true, true).Include(t => t.TrialEmailNoticeUserList).FirstOrDefaultAsync()).IfNullThrowException();


                List<TrialEmailNoticeUser> trialEmailNoticeUsers = new List<TrialEmailNoticeUser>();


                foreach (var item in addOrEditTrialEmailNoticeConfig.ToUserIdList)
                {
                    trialEmailNoticeUsers.Add(new TrialEmailNoticeUser() { EmailUserType = EmailUserType.To, UserId = item, TrialEmailNoticeConfigId = entity.Id });

                }

                foreach (var item in addOrEditTrialEmailNoticeConfig.CopyUserIdList)
                {
                    trialEmailNoticeUsers.Add(new TrialEmailNoticeUser() { EmailUserType = EmailUserType.Copy, UserId = item, TrialEmailNoticeConfigId = entity.Id });

                }
                await _repository.AddRangeAsync(trialEmailNoticeUsers);

                await _trialEmailNoticeConfigRepository.SaveChangesAsync();

                return ResponseOutput.Ok();
            }


        }


        [HttpDelete("{trialEmailNoticeConfigId:guid}")]
        public async Task<IResponseOutput> DeleteTrialEmailNoticeConfig(Guid trialEmailNoticeConfigId)
        {
            var success = await _trialEmailNoticeConfigRepository.DeleteFromQueryAsync(t => t.Id == trialEmailNoticeConfigId, true);

            return ResponseOutput.Ok();
        }


    }
}
